# -*- coding: utf-8 -*-
#
############################################################################
#
# (c) 2006 Florian Birée aka Thesa <florian.biree@laposte.net> 
# (c) 2006 Achraf Cherti aka Asher256 <achrafcherti@gmail.com>
#
# Website: <URL:http://casetta.tuxfamily.org>
# 
# Version 0.2.0
#
# changelog:
#
# # version 0.2.0:
#
# o first version (version number aligned on casetta_cli)
#
############################################################################
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 
# 02110-1301, USA.
#
# http://www.gnu.org/copyleft/gpl.html
#
############################################################################
"""Preference input/output functions for casetta_cli"""

__author__ = "Florian Birée, Achraf Cherti"
__version__ = "0.2.0"
__license__ = "GPL"
__copyright__ = "Copyright (c) 2006, Florian Birée, Achraf Cherti"
__revision__ = "$Revision: $"
# $Source: $
__date__ = "$Date: $"

# Imports
import os
import ConfigParser

# Functions
def load():
    """Load a config file"""
    global default_tool, default_port, other_tool_format, other_tool_input, \
           other_tool_output
    try:
        config = ConfigParser.ConfigParser()
        config.read(config_file)
        default_tool = config.get("Default settings", "default tool")
        default_port = config.get("Default settings", "default port")
        
        other_tool_format = config.get("Other tool", "format")
        other_tool_input = config.get("Other tool", "input command line")
        other_tool_output = config.get("Other tool", "output command line")
    except IOError:
        return
    except ConfigParser.NoOptionError:
        return
    except ConfigParser.NoSectionError:
        return

def define(name, val):
    """Change the setting name to the value val"""
    global default_tool, default_port, other_tool_format, other_tool_input, \
           other_tool_output
    globals()[name] = val
    afile = open(config_file, 'w' )
    config = ConfigParser.ConfigParser()
    config.add_section("Default settings")
    config.set("Default settings", "default tool", default_tool)
    config.set("Default settings", "default port", default_port)
    config.add_section("Other tool")
    config.set("Other tool", "format", other_tool_format)
    config.set("Other tool", "input command line", other_tool_input)
    config.set("Other tool", "output command line", other_tool_output)
    config.write(afile)
    afile.close()

# Default values
config_file = os.path.join(os.path.expanduser('~'), '.casetta')
# [Default settings] section
if os.name == 'posix':
    default_tool = 'casio_cafix'
    default_port = '/dev/ttyS0'
else:
    default_tool = ''
    default_port = ''
# [Other tool] section
other_tool_format = ''
other_tool_input = ''
other_tool_output = ''
